var ID = 'BlobPipe';
var BlobPipe = function () {
    // console.log("BlobPipe ")
    this.id = ID;
    this.async = true;
    this.pipeline = null;
};

BlobPipe.prototype.init = function (cb) {
    //在这之前 把 部分 mpq，  reshash.json加载到 window， 
    if (!window['resFileData']) {
        window['resFileData'] = {};
    }
    //mpq
    // var gamever = getQueryValue("gamever");
    // gamever = gamever ? "?" + gamever : "";
    window["__loadZipRes"]("/client_json1/merge/advance.txt", window['resFileData'], function () {
        console.log('----加载成功');
        window['advanceJsonList'] = [];
        var resfile = window['resFileData'];
        for (var i in resfile) {
            window['advanceJsonList'].push(i);
        }
        cb()
    }, this);

}
BlobPipe.ID = ID;

BlobPipe.prototype.handle = function (item, callback) {
    //在这里 对json 进行hook
    if (item.type == "uuid") {
        //走我们mpq
        return null;
    }
    if (item.type == "jpg" || item.type == "png" || item.type == "bin" || item.type == "text" || item.type == "js" || item.type == "mp3") {
        this.getResHash(item);
        return null;
    }
    return null;
};

BlobPipe.prototype.xhr_load_js = function (url, item, callback) {
    var self = this
    var xhr = cc.loader.getXMLHttpRequest();
    url = window["ResMD5"].rename(url);
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 300)) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;

            function loadHandler() {
                // console.log("onLoadComplete load js ",url)
                item.states[cc.loader.downloader.id] = cc.Pipeline.ItemState.COMPLETE;
                callback(null, item.url);
            }
            self.loadScriptFromMemory(this.response, loadHandler);
            xhr = null;
            // console.log("load js ",url)
        } else if (xhr.status >= 400 && xhr.status < 600) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            self.xhr_load_js(url, item, callback)
        }
    };
    xhr.onerror = function () {
        self.xhr_load_js(url, item, callback)
    }
    xhr.ontimeout = function () {
        self.xhr_load_js(url, item, callback)
    }
    xhr.responseType = "arraybuffer";
    xhr.open("GET", url, true);
    xhr.timeout = 60000;
    xhr.send();
}

BlobPipe.prototype.loadScriptFromUrl = function (e, t) {
    var r = window.document.createElement("script");
    r.type = "text/javascript",
        r.src = e,
        r.onload = t.bind(this),
        document.body.appendChild(r)
}
BlobPipe.prototype.loadScriptFromMemory = function (e, t) {
    var r = this,
        i = URL.createObjectURL(new Blob([e]));
    this.loadScriptFromUrl(i, function (e) {
        // console.log("remove ",i)
        URL.revokeObjectURL(i),
            t.call(r, e)
    })
}
BlobPipe.prototype.loadUrl = function (url, callback) {
    var _self = this
    var xhr = cc.loader.getXMLHttpRequest();
    url = window["ResMD5"].rename(url);
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 300)) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            xhr = null;
            // console.log("onLoadComplete",url);
            callback(this.response);

        } else if (xhr.status >= 400 && xhr.status < 600) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            _self.loadUrl(url, callback)
        }
    };
    xhr.onerror = function () {
        _self.loadUrl(url, callback)
    }
    xhr.ontimeout = function () {
        _self.loadUrl(url, callback)
    }
    xhr.responseType = "text";
    xhr.open("GET", url, true);
    xhr.timeout = 60000;
    xhr.send();
}

/**
 * 获取资源的hash值
 * @param key :string
 * @returns value :string
 */
BlobPipe.prototype.getResHash = function (item) {
    var key = item.url;
    //增加缓存
    if (!window['__urlHashMap']) {
        window['__urlHashMap'] = {};
    }
    if (!window['__urlHashMap'][key]) {
        var cryptKey = window["ResMD5"].crypt(key);
        if (window['resHashMap'] && window['resHashMap'][cryptKey]) {
            window['__urlHashMap'][key] = window['resHashMap'][cryptKey];
        } else {
            console.error("reshash key ", key);
            window['__urlHashMap'][key] = "1599051886"; //默认值
        }
    }
    var hash = window['__urlHashMap'][key];
    if (window['resHashMap_local'] && window['resHashMap_local'][key] && window['resHashMap_local'][key] == hash) {
        item.loadLocal = true;
    } else {
        item.loadLocal = false;
    }
    item.hashParam = hash;
    return hash;
}
/**
 * 替换字符串中所有 指定字符串
 * @param {*} str 目标字符串
 * @param {*} ostr 需要替换的内容
 * @param {*} nstr 替换目标内容
 */
BlobPipe.prototype.replaceAll = function (str, ostr, nstr) {
    var reg = new RegExp(ostr, "g"); //创建正则RegExp对象
    return str.replace(reg, nstr);
}

function loadjson(data, item, uuid, callback, getJson, state) {
    var info = data[uuid];
    if (state) {
        // if(!window['resFileData']){
        //     window['resFileData'] = {}
        // }
        // if(!window['resFileData'][uuid]){
        //     window['resFileData'][uuid] = info
        // }
    }
    // var info = window['resFileData'][uuid]
    if (info) {
        var tmp;
        if (info.jsonObj) {
            tmp = info.jsonObj;
        } else {
            var fileInfo = info;
            var mpqBuff = fileInfo.data;
            var encodedString = '';
            var chunk = 8 * 1024;
            var i;
            var fcount = Math.ceil(fileInfo.length / chunk);
            for (i = 0; i < fcount * chunk; i += chunk) {
                var t_len = chunk
                if ((i + chunk) > fileInfo.length) {
                    t_len = fileInfo.length - i;
                }
                var tmp = new Uint8Array(mpqBuff, fileInfo.begin + i, t_len);
                encodedString += String.fromCharCode.apply(null, tmp);
            }
            var decodedString = decodeURIComponent(escape((encodedString))); //没有这一步中文会乱码
            tmp = JSON.parse(decodedString + "");
            info.jsonObj = tmp;
            delete info.data;
            if ((!window['advanceJsonList'] || window['advanceJsonList'].indexOf(item.url) == -1) && cc.sys.isBrowser && cc.sys.os == cc.sys.OS_IOS) {
                window.MPQDB && window.MPQDB.pJson.put({
                    id: uuid,
                    val: info
                })
            }
        }
        callback(null, tmp);
    } else {
        //只有json或者plist资源走这里
        //szy 添加atlas格式  动态加载活动spine资源时altas走这里
        if (item.url.indexOf(".json") > 1 || item.url.indexOf(".plist") > 1 || item.url.indexOf(".tmx") > 1 || item.url.indexOf(".atlas") > 1 || item.url.indexOf(".txt") > 1) {
            getJson(item, callback);
        } else if (CC_DEBUG) {
            console.error("加载异常:" + item.url);
        }
    }
}
window["extGetJson"] = function (item, callback, getJson) {
    var uuid = item.url.split("/").pop();
    if (!window.MPQDB || window['resFileData'] && window['resFileData'][uuid]) {
        loadjson(window['resFileData'], item, uuid, callback, getJson)
    } else {
        window.MPQDB.pJson.get(uuid, (e, data) => {
            if (data) {
                loadjson({
                    [data.id]: data.val
                }, item, uuid, callback, getJson, 1)
            } else {
                window.MPQDB.pJson.get('allJson', (e, data2) => {
                    loadjson(data2 && data2.val || {}, item, uuid, callback, getJson, 1)
                })
            }
        })
    }

}

/*********************** 处理mpq的方法 ***************************/

function __loadUrl(url, type, callback) {
    var xhr = cc.loader.getXMLHttpRequest();
    url = window["ResMD5"].rename(url);
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 300)) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            xhr = null;
            // console.log("onLoadComplete",url);
            callback(this.response);

        } else if (xhr.status >= 400 && xhr.status < 600) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            __loadUrl(url, type, callback)
        }
    };
    xhr.onerror = function () {
        __loadUrl(url, type, callback)
    }
    xhr.ontimeout = function () {
        __loadUrl(url, type, callback)
    }
    xhr.responseType = type;
    xhr.open("GET", url, true);
    xhr.timeout = 60000;
    xhr.send();
}


window["__loadZipRes"] = function (zipName, out, callback, context) {
    var projectResURL = window["ResMD5"].turnSSL(GlobalConfig.projectResURL);
    __loadUrl(projectResURL + zipName, "arraybuffer", function (data) {
        window["__getMPQData"](data, out, function () {
            callback.call(context);
            out = null;
        }, this);
    }, function () {
        console.log(zipName + "载入失败,50毫秒后重试:" + zipName);
        setTimeout(function () {
            window["__loadZipRes"](zipName, out, callback, context);
        }, 50)
    })
}

window["__getMPQData"] = function (buffMPQ, out, callBack, context) {
    console.time("buffMPQ")
    var mpqData = new DataView(buffMPQ);
    var offset = 0;
    var filesLen = mpqData.getInt16(offset);
    window["__parseMPQ"](0, filesLen, 2, mpqData, buffMPQ, out, callBack, context);
    out = null;
    console.timeEnd("buffMPQ")
}
window["__parseMPQ"] = function (currentIdx, length, offset, mpqData, mpqBuff, out, callBack, context) {
    for (var findex = 0; findex < length; findex++) {
        var fileInfo = {};
        var fileNameLen = mpqData.getInt16(offset);
        offset += 2;
        var name_8buf = new Uint8Array(mpqBuff, offset, fileNameLen);
        var fileName = String.fromCharCode.apply(null, name_8buf).split(".");

        offset += fileNameLen;
        fileInfo.begin = mpqData.getUint32(offset);
        offset += 4;
        fileInfo.length = mpqData.getUint32(offset);
        offset += 4;
        fileInfo.suffix = fileName[1];
        if (fileInfo.suffix == "json" || fileInfo.suffix == "txt") {
            out[fileName[0] + "." + fileName[1]] = fileInfo;
            fileInfo.data = mpqBuff;
        }
    }
    callBack.call(context);
    out = null;
}