// QQPlay window need to be inited first
if (false) {
    BK.Script.loadlib('GameRes://libs/qqplay-adapter.js');
}

window.boot = function () {
    var blobdown = new BlobPipe()
    var pipeBeforeDownloader = cc.loader.subPackPipe || cc.loader.md5Pipe || cc.loader.assetLoader;
    cc.loader.insertPipeAfter(pipeBeforeDownloader, blobdown);

    blobdown.init(function () {
        var settings = window._CCSettings;
        window._CCSettings = undefined;

        if (!settings.debug) {
            var uuids = settings.uuids;

            var rawAssets = settings.rawAssets;
            var assetTypes = settings.assetTypes;
            var realRawAssets = settings.rawAssets = {};
            for (var mount in rawAssets) {
                var entries = rawAssets[mount];
                var realEntries = realRawAssets[mount] = {};
                for (var id in entries) {
                    var entry = entries[id];
                    var type = entry[1];
                    // retrieve minified raw asset
                    if (typeof type === 'number') {
                        entry[1] = assetTypes[type];
                    }
                    // retrieve uuid
                    realEntries[uuids[id] || id] = entry;
                }
            }

            var scenes = settings.scenes;
            for (var i = 0; i < scenes.length; ++i) {
                var scene = scenes[i];
                if (typeof scene.uuid === 'number') {
                    scene.uuid = uuids[scene.uuid];
                }
            }

            var packedAssets = settings.packedAssets;
            for (var packId in packedAssets) {
                var packedIds = packedAssets[packId];
                for (var j = 0; j < packedIds.length; ++j) {
                    if (typeof packedIds[j] === 'number') {
                        packedIds[j] = uuids[packedIds[j]];
                    }
                }
            }

            var subpackages = settings.subpackages;
            for (var subId in subpackages) {
                var uuidArray = subpackages[subId].uuids;
                if (uuidArray) {
                    for (var k = 0, l = uuidArray.length; k < l; k++) {
                        if (typeof uuidArray[k] === 'number') {
                            uuidArray[k] = uuids[uuidArray[k]];
                        }
                    }
                }
            }
        }

        function setLoadingDisplay() {
            // Loading splash scene
            var splash = document.getElementById('splash');
            var progressBar = splash.querySelector('.progress-bar span');
            cc.loader.onProgress = function (completedCount, totalCount, item) {
                var percent = 100 * completedCount / totalCount;
                if (progressBar) {
                    progressBar.style.width = percent.toFixed(2) + '%';
                }
            };
            splash.style.display = 'none';
            // progressBar.style.width = '0%';

            cc.director.once(cc.Director.EVENT_AFTER_SCENE_LAUNCH, function () {
                splash.style.display = 'none';

                //如果已点击开始游戏  
                if (window.__require("GameStart")) {
                    window.IndexGlobal && window.IndexGlobal.sendButton(window.IndexGlobal.buttonId.b8);
                } else {
                    window.IndexGlobal && window.IndexGlobal.sendButton(window.IndexGlobal.buttonId.b9);
                }
                window.IndexGlobal && window.IndexGlobal.sendButton(window.IndexGlobal.buttonId.b7);
            });
        }

        var onStart = function () {
            //埋点 project.js加载完成，GameCanvas场景加载完成，assets初始化完成 60035  
            window.IndexGlobal && window.IndexGlobal.sendButton(window.IndexGlobal.buttonId.b10);
            cc.loader.downloader._subpackages = settings.subpackages;

            cc.view.enableRetina(true);
            cc.view.resizeWithBrowserSize(true);

            if (!false && !false) {
                if (cc.sys.isBrowser) {
                    setLoadingDisplay();
                }

                if (cc.sys.isMobile) {
                    if (settings.orientation === 'landscape') {
                        cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
                    } else if (settings.orientation === 'portrait') {
                        cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
                    }
                    //cc.view.enableAutoFullScreen([
                    //    cc.sys.BROWSER_TYPE_BAIDU,
                    //    cc.sys.BROWSER_TYPE_WECHAT,
                    //    cc.sys.BROWSER_TYPE_MOBILE_QQ,
                    //    cc.sys.BROWSER_TYPE_MIUI,
                    //].indexOf(cc.sys.browserType) < 0);
                    cc.view.enableAutoFullScreen(false);
                }

                // Limit downloading max concurrent task to 2,
                // more tasks simultaneously may cause performance draw back on some android system / browsers.
                // You can adjust the number based on your own test result, you have to set it before any loading process to take effect.
                if (cc.sys.isBrowser && cc.sys.os === cc.sys.OS_ANDROID) {
                    cc.macro.DOWNLOAD_MAX_CONCURRENT = 2;
                }
            }

            function loadScene(launchScene) {
                cc.director.loadScene(launchScene,
                    function (err) {
                        if (!err) {
                            if (cc.sys.isBrowser) {
                                // show canvas
                                var canvas = document.getElementById('GameCanvas');
                                canvas.style.visibility = '';
                                var div = document.getElementById('GameDiv');
                                if (div) {
                                    div.style.backgroundImage = '';
                                }
                            }
                            cc.loader.onProgress = null;
                            console.log('Success to load scene: ' + launchScene);
                        } else if (CC_BUILD) {
                            setTimeout(function () {
                                loadScene(launchScene);
                            }, 1000);
                        }
                    }
                );

            }

            var launchScene = settings.launchScene;

            try {
                var _IndexGlobal = window.IndexGlobal;
                var _pa = _IndexGlobal.Params;
                var _loadImg = _pa.loading_img || '8_3';
                var resRootPath = ResMD5 && ResMD5.getPath ? ResMD5.getPath() : window.GlobalConfig.ResPath
                var _sa = resRootPath + '/i/com/bg/' + _loadImg + '.jpg';
                //console.log('loading_img==', _loadImg);
                cc.loader.load(_sa, function (err, texture) {
                    // Use texture to create sprite frame
                    // console.log(texture);
                    if (!err) {
                        window['__bgSpriteFrame__'] = new cc.SpriteFrame(texture);
                    }
                    loadScene(launchScene);
                });
            } catch (error) {
                // load scene
                //如果出问题，则使用默认方式
                loadScene(launchScene);
            }
        };

        // jsList
        var jsList = settings.jsList;

        //szy GlobalConfig.js不再做为插件脚本加载，在index.html中直接加载；
        //(因为脚本中的端口会根据GameId的不同而不同，所以做此调整)
        for (var i = 0; i < jsList.length; i++) {
            var _js = jsList[i];
            if (_js.indexOf("GlobalConfig.js") >= 0 || _js.indexOf("GlobalCfg.js") >= 0) {
                jsList.splice(i, 1)
                break
            }
        }

        if (false) {
            BK.Script.loadlib();
        } else {
            var bundledScript = settings.debug ? 'src1/project.dev.js' : 'src1/project.js';
            if (jsList) {
                jsList = jsList.map(function (x) {
                    return 'src1/' + x;
                });
                jsList.push(bundledScript);
            } else {
                jsList = [bundledScript];
            }
        }

        var option = {
            id: 'GameCanvas',
            scenes: settings.scenes,
            debugMode: settings.debug ? cc.debug.DebugMode.INFO : cc.debug.DebugMode.ERROR,
            showFPS: !false && settings.debug,
            frameRate: 60,
            jsList: jsList,
            groupList: settings.groupList,
            collisionMatrix: settings.collisionMatrix,
        }

        // init assets
        cc.AssetLibrary.init({
            libraryPath: 'res1/import',
            rawAssetsBase: 'res1/raw-',
            rawAssets: settings.rawAssets,
            packedAssets: settings.packedAssets,
            md5AssetsMap: settings.md5AssetsMap,
            subpackages: settings.subpackages
        });

        cc.game.run(option, onStart);
    })
};

// main.js is qqplay and jsb platform entry file, so we must leave platform init code here
if (false) {
    BK.Script.loadlib('GameRes://src1/settings.js');
    BK.Script.loadlib();
    BK.Script.loadlib('GameRes://libs/qqplay-downloader.js');

    var ORIENTATIONS = {
        'portrait': 1,
        'landscape left': 2,
        'landscape right': 3
    };
    BK.Director.screenMode = ORIENTATIONS[window._CCSettings.orientation];
    initAdapter();
    cc.game.once(cc.game.EVENT_ENGINE_INITED, function () {
        initRendererAdapter();
    });

    qqPlayDownloader.REMOTE_SERVER_ROOT = "";
    var prevPipe = cc.loader.md5Pipe || cc.loader.assetLoader;
    cc.loader.insertPipeAfter(prevPipe, qqPlayDownloader);

    window.boot();
} else if (window.jsb) {

    var isRuntime = (typeof loadRuntime === 'function');
    if (isRuntime) {
        require('src1/settings.js');
        require('src1/cocos2d-runtime.js');
        require('jsb-adapter/engine/index.js');
    } else {
        require('src1/settings.js');
        require('src1/cocos2d-jsb.js');
        require('jsb-adapter/jsb-engine.js');
    }

    cc.macro.CLEANUP_IMAGE_CACHE = true;
    window.boot();
}